VERSION 5.00
Begin VB.UserControl XmlTextbox 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   ToolboxBitmap   =   "XmlTextbox.ctx":0000
   Begin VB.TextBox txtXml 
      Appearance      =   0  'Flat
      BorderStyle     =   0  'None
      Height          =   3270
      Left            =   210
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   105
      Width           =   4320
   End
End
Attribute VB_Name = "XmlTextbox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Dim m_oDOM As MSXML.DOMDocument

'Default Property Values:
Const m_def_DTD = ""
Const m_def_AutoCheck = True
Const m_def_ParseErrorReason = ""
Const m_def_ParseErrorSource = ""
Const m_def_ParseErrorPosition = 0
Const m_def_Enabled = 0
Const m_def_BackStyle = 0
Const m_def_FontTransparent = 0
Const m_def_NoUserElements = False

'Property Variables:
Dim m_DTD As String
Dim m_AutoCheck As Boolean
Dim m_ParseErrorReason As String
Dim m_ParseErrorSource As String
Dim m_ParseErrorPosition As Integer
Dim m_Enabled As Boolean
Dim m_BackStyle As Integer
Dim m_FontTransparent As Boolean
Dim m_NoUserElements As Boolean

'Event Declarations:
Event Change() 'MappingInfo=txtXml,txtXml,-1,Change
Attribute Change.VB_Description = "Occurs when the contents of a control have changed."
Event ParseError()
Event ParseOK()
Event Click()
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Event DblClick()
Attribute DblClick.VB_Description = "Occurs when the user presses and releases a mouse button and then presses and releases it again over an object."
Event KeyDown(KeyCode As Integer, Shift As Integer)
Attribute KeyDown.VB_Description = "Occurs when the user presses a key while an object has the focus."
Event KeyPress(KeyAscii As Integer)
Attribute KeyPress.VB_Description = "Occurs when the user presses and releases an ANSI key."
Event KeyUp(KeyCode As Integer, Shift As Integer)
Attribute KeyUp.VB_Description = "Occurs when the user releases a key while an object has the focus."
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."


'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtXml,txtXml,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = txtXml.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    txtXml.BackColor() = New_BackColor
    PropertyChanged "BackColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtXml,txtXml,-1,ForeColor
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
    ForeColor = txtXml.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    txtXml.ForeColor() = New_ForeColor
    PropertyChanged "ForeColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,0
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = m_Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    m_Enabled = New_Enabled
    PropertyChanged "Enabled"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtXml,txtXml,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
    Set Font = txtXml.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set txtXml.Font = New_Font
    PropertyChanged "Font"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,0
Public Property Get BackStyle() As Integer
Attribute BackStyle.VB_Description = "Indicates whether a Label or the background of a Shape is transparent or opaque."
    BackStyle = m_BackStyle
End Property

Public Property Let BackStyle(ByVal New_BackStyle As Integer)
    m_BackStyle = New_BackStyle
    PropertyChanged "BackStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BorderStyle
Public Property Get BorderStyle() As Integer
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
    BorderStyle = UserControl.BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As Integer)
    UserControl.BorderStyle() = New_BorderStyle
    PropertyChanged "BorderStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=5
Public Sub Refresh()
Attribute Refresh.VB_Description = "Forces a complete repaint of a object."
     
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtXml,txtXml,-1,FontBold
Public Property Get FontBold() As Boolean
Attribute FontBold.VB_Description = "Returns/sets bold font styles."
    FontBold = txtXml.FontBold
End Property

Public Property Let FontBold(ByVal New_FontBold As Boolean)
    txtXml.FontBold() = New_FontBold
    PropertyChanged "FontBold"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtXml,txtXml,-1,FontItalic
Public Property Get FontItalic() As Boolean
Attribute FontItalic.VB_Description = "Returns/sets italic font styles."
    FontItalic = txtXml.FontItalic
End Property

Public Property Let FontItalic(ByVal New_FontItalic As Boolean)
    txtXml.FontItalic() = New_FontItalic
    PropertyChanged "FontItalic"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtXml,txtXml,-1,FontName
Public Property Get FontName() As String
Attribute FontName.VB_Description = "Specifies the name of the font that appears in each row for the given level."
    FontName = txtXml.FontName
End Property

Public Property Let FontName(ByVal New_FontName As String)
    txtXml.FontName() = New_FontName
    PropertyChanged "FontName"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtXml,txtXml,-1,FontSize
Public Property Get FontSize() As Single
Attribute FontSize.VB_Description = "Specifies the size (in points) of the font that appears in each row for the given level."
    FontSize = txtXml.FontSize
End Property

Public Property Let FontSize(ByVal New_FontSize As Single)
    txtXml.FontSize() = New_FontSize
    PropertyChanged "FontSize"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtXml,txtXml,-1,FontStrikethru
Public Property Get FontStrikethru() As Boolean
Attribute FontStrikethru.VB_Description = "Returns/sets strikethrough font styles."
    FontStrikethru = txtXml.FontStrikethru
End Property

Public Property Let FontStrikethru(ByVal New_FontStrikethru As Boolean)
    txtXml.FontStrikethru() = New_FontStrikethru
    PropertyChanged "FontStrikethru"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,0
Public Property Get FontTransparent() As Boolean
Attribute FontTransparent.VB_Description = "Returns/sets a value that determines whether background text/graphics on a Form, Printer or PictureBox are displayed."
    FontTransparent = m_FontTransparent
End Property

Public Property Let FontTransparent(ByVal New_FontTransparent As Boolean)
    m_FontTransparent = New_FontTransparent
    PropertyChanged "FontTransparent"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtXml,txtXml,-1,FontUnderline
Public Property Get FontUnderline() As Boolean
Attribute FontUnderline.VB_Description = "Returns/sets underline font styles."
    FontUnderline = txtXml.FontUnderline
End Property

Public Property Let FontUnderline(ByVal New_FontUnderline As Boolean)
    txtXml.FontUnderline() = New_FontUnderline
    PropertyChanged "FontUnderline"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtXml,txtXml,-1,ScrollBars
Public Property Get ScrollBars() As Integer
Attribute ScrollBars.VB_Description = "Returns/sets a value indicating whether an object has vertical or horizontal scroll bars."
    ScrollBars = txtXml.ScrollBars
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtXml,txtXml,-1,MultiLine
Public Property Get MultiLine() As Boolean
    MultiLine = txtXml.MultiLine
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtXml,txtXml,-1,Text
Public Property Get Text() As String
Attribute Text.VB_Description = "Returns/sets the text contained in the control."
    Text = txtXml.Text
End Property

Public Property Let Text(ByVal New_Text As String)
    txtXml.Text = New_Text
    PropertyChanged "Text"
   
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,False
Public Property Get NoUserElements() As Boolean
Attribute NoUserElements.VB_Description = "Prevent the kytboard entry of '<' and '>'"
    NoUserElements = m_NoUserElements
End Property

Public Property Let NoUserElements(ByVal New_NoUserElements As Boolean)
    m_NoUserElements = New_NoUserElements
    PropertyChanged "NoUserElements"
End Property

Private Sub txtXml_Change()
    RaiseEvent Change
    
    ' Clear error info since we don't know the
    ' current error state
    m_ParseErrorReason = ""
    m_ParseErrorPosition = 0
    m_ParseErrorSource = ""

    If AutoCheck Then
        Call WellFormedCheck
    End If
End Sub

Private Sub txtXml_KeyUp(KeyCode As Integer, Shift As Integer)
    If m_NoUserElements Then
        If ((KeyCode = 190) Or (KeyCode = 188)) And Shift > 0 Then
            SendKeys "{Bksp}"
          '  Beep
            DoEvents
        End If
    End If
End Sub

Private Sub UserControl_Initialize()
    Set m_oDOM = New MSXML.DOMDocument
End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_Enabled = m_def_Enabled
    m_BackStyle = m_def_BackStyle
    m_FontTransparent = m_def_FontTransparent
    m_NoUserElements = m_def_NoUserElements
    m_AutoCheck = m_def_AutoCheck
    m_DTD = m_def_DTD
    m_ParseErrorReason = m_def_ParseErrorReason
    m_ParseErrorSource = m_def_ParseErrorSource
    m_ParseErrorPosition = m_def_ParseErrorPosition
      
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    txtXml.BackColor = PropBag.ReadProperty("BackColor", &H80000005)
    txtXml.ForeColor = PropBag.ReadProperty("ForeColor", &H80000008)
    m_Enabled = PropBag.ReadProperty("Enabled", m_def_Enabled)
    Set txtXml.Font = PropBag.ReadProperty("Font", Ambient.Font)
    m_BackStyle = PropBag.ReadProperty("BackStyle", m_def_BackStyle)
    UserControl.BorderStyle = PropBag.ReadProperty("BorderStyle", 0)
    txtXml.FontBold = PropBag.ReadProperty("FontBold", 0)
    txtXml.FontItalic = PropBag.ReadProperty("FontItalic", 0)
    txtXml.FontName = PropBag.ReadProperty("FontName", "")
    txtXml.FontSize = PropBag.ReadProperty("FontSize", 0)
    txtXml.FontStrikethru = PropBag.ReadProperty("FontStrikethru", 0)
    m_FontTransparent = PropBag.ReadProperty("FontTransparent", m_def_FontTransparent)
    txtXml.FontUnderline = PropBag.ReadProperty("FontUnderline", 0)
    txtXml.Text = PropBag.ReadProperty("Text", "")
    m_NoUserElements = PropBag.ReadProperty("NoUserElements", m_def_NoUserElements)
    m_AutoCheck = PropBag.ReadProperty("AutoCheck", m_def_AutoCheck)
    m_DTD = PropBag.ReadProperty("DTD", m_def_DTD)
    m_ParseErrorReason = PropBag.ReadProperty("ParseErrorReason", m_def_ParseErrorReason)
    m_ParseErrorSource = PropBag.ReadProperty("ParseErrorSource", m_def_ParseErrorSource)
    m_ParseErrorPosition = PropBag.ReadProperty("ParseErrorPosition", m_def_ParseErrorPosition)
    txtXml.SelLength = PropBag.ReadProperty("SelLength", 0)
    txtXml.SelStart = PropBag.ReadProperty("SelStart", 0)
    txtXml.SelText = PropBag.ReadProperty("SelText", "")
End Sub

Private Sub UserControl_Resize()
    txtXml.Move 0, 0, ScaleWidth, ScaleHeight
End Sub

Private Sub UserControl_Terminate()
    Set m_oDOM = Nothing
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("BackColor", txtXml.BackColor, &H80000005)
    Call PropBag.WriteProperty("ForeColor", txtXml.ForeColor, &H80000008)
    Call PropBag.WriteProperty("Enabled", m_Enabled, m_def_Enabled)
    Call PropBag.WriteProperty("Font", txtXml.Font, Ambient.Font)
    Call PropBag.WriteProperty("BackStyle", m_BackStyle, m_def_BackStyle)
    Call PropBag.WriteProperty("BorderStyle", UserControl.BorderStyle, 0)
    Call PropBag.WriteProperty("FontBold", txtXml.FontBold, 0)
    Call PropBag.WriteProperty("FontItalic", txtXml.FontItalic, 0)
    Call PropBag.WriteProperty("FontName", txtXml.FontName, "")
    Call PropBag.WriteProperty("FontSize", txtXml.FontSize, 0)
    Call PropBag.WriteProperty("FontStrikethru", txtXml.FontStrikethru, 0)
    Call PropBag.WriteProperty("FontTransparent", m_FontTransparent, m_def_FontTransparent)
    Call PropBag.WriteProperty("FontUnderline", txtXml.FontUnderline, 0)
    Call PropBag.WriteProperty("Text", txtXml.Text, "")
    Call PropBag.WriteProperty("NoUserElements", m_NoUserElements, m_def_NoUserElements)
    Call PropBag.WriteProperty("AutoCheck", m_AutoCheck, m_def_AutoCheck)
    Call PropBag.WriteProperty("DTD", m_DTD, m_def_DTD)
    Call PropBag.WriteProperty("ParseErrorReason", m_ParseErrorReason, m_def_ParseErrorReason)
    Call PropBag.WriteProperty("ParseErrorSource", m_ParseErrorSource, m_def_ParseErrorSource)
    Call PropBag.WriteProperty("ParseErrorPosition", m_ParseErrorPosition, m_def_ParseErrorPosition)
    Call PropBag.WriteProperty("SelLength", txtXml.SelLength, 0)
    Call PropBag.WriteProperty("SelStart", txtXml.SelStart, 0)
    Call PropBag.WriteProperty("SelText", txtXml.SelText, "")
End Sub

Public Property Get DTD() As String
    DTD = m_DTD
End Property

Public Property Let DTD(ByVal New_DTD As String)
    m_DTD = New_DTD
    PropertyChanged "DTD"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,False
Public Property Get AutoCheck() As Boolean
Attribute AutoCheck.VB_Description = "Raise error info on entry of malformed XML"
    AutoCheck = m_AutoCheck
End Property

Public Property Let AutoCheck(ByVal New_AutoCheck As Boolean)
    m_AutoCheck = New_AutoCheck
    PropertyChanged "AutoCheck"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=13,1,2,
Public Property Get ParseErrorReason() As String
Attribute ParseErrorReason.VB_Description = "Parse error reason returned from XML parser"
Attribute ParseErrorReason.VB_MemberFlags = "400"
    ParseErrorReason = m_ParseErrorReason
End Property

Public Property Let ParseErrorReason(ByVal New_ParseErrorReason As String)
    If Ambient.UserMode = False Then Err.Raise 387
    If Ambient.UserMode Then Err.Raise 382
    m_ParseErrorReason = New_ParseErrorReason
    PropertyChanged "ParseErrorReason"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=13,1,2,
Public Property Get ParseErrorSource() As String
Attribute ParseErrorSource.VB_Description = "Source XML returned from XML parser"
Attribute ParseErrorSource.VB_MemberFlags = "400"
     ParseErrorSource = m_oDOM.ParseError.srcText
End Property

Public Property Let ParseErrorSource(ByVal New_ParseErrorSource As String)
    If Ambient.UserMode = False Then Err.Raise 387
    If Ambient.UserMode Then Err.Raise 382
    m_ParseErrorSource = New_ParseErrorSource
    PropertyChanged "ParseErrorSource"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,1,1,0
Public Property Get ParseErrorPosition() As Integer
Attribute ParseErrorPosition.VB_Description = "Parse error text position returned from XML parser"
    ParseErrorPosition = m_oDOM.ParseError.filepos
End Property

Public Property Let ParseErrorPosition(ByVal New_ParseErrorPosition As Integer)
    If Ambient.UserMode = False Then Err.Raise 387
    If Ambient.UserMode Then Err.Raise 382
    m_ParseErrorPosition = New_ParseErrorPosition
    PropertyChanged "ParseErrorPosition"
End Property

Public Sub WellFormedCheck()
    Dim nIdx As Integer
    Dim s As String
    
    If (Len(m_DTD) > 0) Then
        s = m_DTD & txtXml
        If Not (m_oDOM.loadXML(s)) Then
            Call SetParseErrors
            RaiseEvent ParseError
        Else
            m_ParseErrorReason = ""
            m_ParseErrorPosition = 0
            m_ParseErrorSource = ""
            RaiseEvent ParseOK
        End If
    ElseIf Not (m_oDOM.loadXML(txtXml)) Then
        Call SetParseErrors
        RaiseEvent ParseError
    Else
        m_ParseErrorReason = ""
        m_ParseErrorPosition = 0
        m_ParseErrorSource = ""
        RaiseEvent ParseOK
    End If
End Sub
Private Sub SetParseErrors()
    With m_oDOM.ParseError
        m_ParseErrorReason = .reason
        m_ParseErrorSource = .srcText
        m_ParseErrorPosition = .filepos
    End With
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtXml,txtXml,-1,SelLength
Public Property Get SelLength() As Long
Attribute SelLength.VB_Description = "Returns/sets the number of characters selected."
    SelLength = txtXml.SelLength
End Property

Public Property Let SelLength(ByVal New_SelLength As Long)
    txtXml.SelLength() = New_SelLength
    PropertyChanged "SelLength"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtXml,txtXml,-1,SelStart
Public Property Get SelStart() As Long
Attribute SelStart.VB_Description = "Returns/sets the starting point of text selected."
    SelStart = txtXml.SelStart
End Property

Public Property Let SelStart(ByVal New_SelStart As Long)
    txtXml.SelStart() = New_SelStart
    PropertyChanged "SelStart"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txtXml,txtXml,-1,SelText
Public Property Get SelText() As String
Attribute SelText.VB_Description = "Returns/sets the string containing the currently selected text."
    SelText = txtXml.SelText
End Property

Public Property Let SelText(ByVal New_SelText As String)
    txtXml.SelText() = New_SelText
    PropertyChanged "SelText"
End Property


